package apf.model;

/**
 * Die Beschreibung des Typs hier eingeben.
 * Erstellungsdatum: (07.07.2002 19:58:58)
 * @author: Manuel Krger
 */
public class Palette {
	private int[] fieldColors = null;
	protected transient java.beans.PropertyChangeSupport propertyChange;
	private int fieldAnzahl = 0;
/**
 * Palette - Konstruktorkommentar.
 */
public Palette() {
	
	super();
}
/**
 * Die Methode addPropertyChangeListener wurde zur Untersttzung des Feldes propertyChange generiert.
 */
public synchronized void addPropertyChangeListener(java.beans.PropertyChangeListener listener) {
	getPropertyChange().addPropertyChangeListener(listener);
}
/**
 * Die Methode addPropertyChangeListener wurde zur Untersttzung des Feldes propertyChange generiert.
 */
public synchronized void addPropertyChangeListener(java.lang.String propertyName, java.beans.PropertyChangeListener listener) {
	getPropertyChange().addPropertyChangeListener(propertyName, listener);
}
/**
 * Die Methode create ausfhren.
 * @param Anzahl int
 * @param Kontrast int
 */
public void create(int Anzahl, int Kontrast) {

	// Anzahl = 180 ;

	 setAnzahl(Anzahl); 

	int rot, gruen , blau ; 
	
	int i, c, bright, dark, step ;

	bright = 255 ;
	dark   = bright - Kontrast ;
	step   = Anzahl / 6;

	int value = (bright - dark) / step;

	System.out.println("dark, step, value : " + dark + ", " + step + ", " + value); 
		
	fieldColors = new int [Anzahl];

	i = 0 ; 

	rot  = 255 ; gruen = dark ;
	blau = 255 ;

	do {
		blau = blau - value ; System.out.println ("r, g, b : " + i + ", " + rot + ", " + gruen + ", " + blau) ;
		
		c = 0xFF000000 + (rot << 16) + (gruen << 8) + blau ;
		
		setColors(i++,c) ;
		
	} while (blau > dark);

	do {
		gruen = gruen + value ;	System.out.println ("r, g, b : " + i + ", " + rot + ", " + gruen + ", " + blau) ;
		
		c = 0xFF000000 + (rot << 16) + (gruen << 8) + blau ;
		
		setColors(i++,c) ;
		
	} while (gruen < 255);

	do {
		rot = rot - value ;	System.out.println ("r, g, b : " + i + ", " + rot + ", " + gruen + ", " + blau) ;
		
		c = 0xFF000000 + (rot << 16) + (gruen << 8) + blau ;
		
		setColors(i++,c) ;
		
	} while (rot > dark);

	do {
		blau = blau + value ; System.out.println ("r, g, b : " + i + ", " + rot + ", " + gruen + ", " + blau) ;
		
		c = 0xFF000000 + (rot << 16) + (gruen << 8) + blau ;
		
		setColors(i++,c) ;
		
	} while (blau < 255);

	do {
		gruen = gruen - value ;	System.out.println ("r, g, b : " + i + ", " + rot + ", " + gruen + ", " + blau) ;
		
		c = 0xFF000000 + (rot << 16) + (gruen << 8) + blau ;
		
		setColors(i++,c) ;
		
	} while (gruen > dark);

	do {
		rot = rot + value ;	System.out.println ("r, g, b : " + i + ", " + rot + ", " + gruen + ", " + blau) ;
		
		c = 0xFF000000 + (rot << 16) + (gruen << 8) + blau ;
		
		setColors(i++,c) ;
		
	} while (rot < 255);














	
}
/**
 * berprft die Gleichheit von zwei Objekten. Gibt einen booleschen Wert
 * zurck, um anzugeben, ob dieses Objekt quivalent zum angegebenen Objekt
 * ist. Diese Methode wird verwendet, wenn ein Objekt in einer Hash-Tabelle gespeichert wird.
 * @param obj das Objekt, mit dem verglichen werden soll
 * @return true, wenn diese Objekte gleich sein sollen; andernfalls false.
 * @see java.util.Hashtable
 */
public boolean equals(Object obj) {
	// Hier Code einfgen, um den Empfnger und obj zu vergleichen.
	// Diese Implementierung leitet die Nachricht an die Superkomponente weiter. Sie knnen dies ersetzen oder ergnzen.
	// HINWEIS: obj kann eine Instanz einer beliebigen Klasse sein.
	return super.equals(obj);
}
/**
 * Die Methode firePropertyChange wurde zur Untersttzung des Feldes propertyChange generiert.
 */
public void firePropertyChange(java.beans.PropertyChangeEvent evt) {
	getPropertyChange().firePropertyChange(evt);
}
/**
 * Die Methode firePropertyChange wurde zur Untersttzung des Feldes propertyChange generiert.
 */
public void firePropertyChange(java.lang.String propertyName, int oldValue, int newValue) {
	getPropertyChange().firePropertyChange(propertyName, oldValue, newValue);
}
/**
 * Die Methode firePropertyChange wurde zur Untersttzung des Feldes propertyChange generiert.
 */
public void firePropertyChange(java.lang.String propertyName, java.lang.Object oldValue, java.lang.Object newValue) {
	getPropertyChange().firePropertyChange(propertyName, oldValue, newValue);
}
/**
 * Die Methode firePropertyChange wurde zur Untersttzung des Feldes propertyChange generiert.
 */
public void firePropertyChange(java.lang.String propertyName, boolean oldValue, boolean newValue) {
	getPropertyChange().firePropertyChange(propertyName, oldValue, newValue);
}
/**
 * Ruft den Eigenschaftswert anzahl (int) ab.
 * @return Der Eigenschaftswert anzahl.
 * @see #setAnzahl
 */
public int getAnzahl() {
	return fieldAnzahl;
}
/**
 * Ruft den Eigenschaftswert colors (int[]) ab.
 * @return Der Eigenschaftswert colors.
 * @see #setColors
 */
public int[] getColors() {
	return fieldColors;
}
/**
 * Ruft den Indexeigenschaftswert colors (int) ab.
 * @return Der Eigenschaftswert colors.
 * @param index Der Indexwert im Eigenschafts-Array.
 * @see #setColors
 */
public int getColors(int index) {
	return getColors()[index];
}
/**
 * Accessor fr das Feld propertyChange.
 */
protected java.beans.PropertyChangeSupport getPropertyChange() {
	if (propertyChange == null) {
		propertyChange = new java.beans.PropertyChangeSupport(this);
	};
	return propertyChange;
}
/**
 * Generiert einen Hash-Code fr den Empfnger.
 * Diese Methode wird primr fr
 * Hash-Tabellen untersttzt, die z. B. in java.util zur Verfgung gestellt werden.
 * @return ein Integer-Hash-Code fr den Empfnger
 * @see java.util.Hashtable
 */
public int hashCode() {
	// Hier Code einfgen, um einen Hash-Code fr den Empfnger zu erstellen.
	// Diese Implementierung  leitet die Nachricht an die Superkomponente weiter. Sie knnen dies ersetzen oder ergnzen.
	// HINWEIS: wenn zwei Objekte gleich sind (equals(Object) gibt true zurck), mssen sie denselben Hash-Code aufweisen
	return super.hashCode();
}
/**
 * Die Methode hasListeners wurde zur Untersttzung des Feldes propertyChange generiert.
 */
public synchronized boolean hasListeners(java.lang.String propertyName) {
	return getPropertyChange().hasListeners(propertyName);
}
/**
 * Startet die Anwendung.
 * @param args ein Array von Befehlszeilenargumenten
 */
public static void main(java.lang.String[] args) {
	
	Palette palette = new Palette () ;

	palette.create(30,190) ;
	
}
/**
 * Die Methode removePropertyChangeListener wurde zur Untersttzung des Feldes propertyChange generiert.
 */
public synchronized void removePropertyChangeListener(java.beans.PropertyChangeListener listener) {
	getPropertyChange().removePropertyChangeListener(listener);
}
/**
 * Die Methode removePropertyChangeListener wurde zur Untersttzung des Feldes propertyChange generiert.
 */
public synchronized void removePropertyChangeListener(java.lang.String propertyName, java.beans.PropertyChangeListener listener) {
	getPropertyChange().removePropertyChangeListener(propertyName, listener);
}
/**
 * Definiert den Eigenschaftswert anzahl (int).
 * @param anzahl Der neue Wert fr die Eigenschaft.
 * @see #getAnzahl
 */
public void setAnzahl(int anzahl) {
	int oldValue = fieldAnzahl;
	fieldAnzahl = anzahl;
	firePropertyChange("anzahl", new Integer(oldValue), new Integer(anzahl));
}
/**
 * Definiert den Eigenschaftswert colors (int[]).
 * @param colors Der neue Wert fr die Eigenschaft.
 * @see #getColors
 */
public void setColors(int[] colors) {
	fieldColors = colors;
}
/**
 * Definiert den Indexeigenschaftwert colors (int[]).
 * @param index Der Indexwert im Eigenschafts-Array.
 * @param colors Der neue Wert fr die Eigenschaft.
 * @see #getColors
 */
public void setColors(int index, int colors) {
	fieldColors[index] = colors;
}
/**
 * Gibt eine Zeichenfolge zurck, die den Wert dieses Objekts darstellt.
 * @return eine Zeichenfolgedarstellung des Empfngers
 */
public String toString() {
	// Hier Code einfgen, um den Empfnger auszugeben.
	// Diese Implementierung leitet die Nachricht an die Superkomponente weiter. Sie knnen dies ersetzen oder ergnzen.
	return super.toString();
}
}
