package apf.view;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

import apf.model.*;

/**
 * Die Beschreibung des Typs hier eingeben.
 * Erstellungsdatum: (04.07.2002 11:19:47)
 * @author: Manuel Krger
 */
public class ImagePanel extends JPanel implements ComponentListener, MouseListener, MouseMotionListener, java.beans.PropertyChangeListener {
	Image image ;
	private Fractal ivjFractal = null;
	private Dimension ivjsize = null;
	private double fieldAkt_x = 0;
	private double fieldAkt_y = 0;
/**
 * ImagePanel - Konstruktorkommentar.
 */
public ImagePanel() {
	super();
	initialize();
}
/**
 * ImagePanel - Konstruktorkommentar.
 * @param layout java.awt.LayoutManager
 */
public ImagePanel(java.awt.LayoutManager layout) {
	super(layout);
}
/**
 * ImagePanel - Konstruktorkommentar.
 * @param layout java.awt.LayoutManager
 * @param isDoubleBuffered boolean
 */
public ImagePanel(java.awt.LayoutManager layout, boolean isDoubleBuffered) {
	super(layout, isDoubleBuffered);
}
/**
 * ImagePanel - Konstruktorkommentar.
 * @param isDoubleBuffered boolean
 */
public ImagePanel(boolean isDoubleBuffered) {
	super(isDoubleBuffered);
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle ComponentListener.
 * @param e java.awt.event.ComponentEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void componentHidden(java.awt.event.ComponentEvent e) {
	// user code begin {1}
	// user code end
	// user code begin {2}
	// user code end
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle ComponentListener.
 * @param e java.awt.event.ComponentEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void componentMoved(java.awt.event.ComponentEvent e) {
	// user code begin {1}
	// user code end
	// user code begin {2}
	// user code end
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle ComponentListener.
 * @param e java.awt.event.ComponentEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void componentResized(java.awt.event.ComponentEvent e) {
	// user code begin {1}
	// user code end
	if (e.getSource() == this) 
		connPtoP1SetTarget();
	// user code begin {2}
	// user code end
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle ComponentListener.
 * @param e java.awt.event.ComponentEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void componentShown(java.awt.event.ComponentEvent e) {
	// user code begin {1}
	// user code end
	// user code begin {2}
	// user code end
}
/**
 * connEtoC1:  (ImagePanel.mouseMotion.mouseMoved(java.awt.event.MouseEvent) --> ImagePanel.imagePanel_MouseMoved(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
private void connEtoC1(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.imagePanel_MouseMoved(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC2:  (ImagePanel.mouse.mouseClicked(java.awt.event.MouseEvent) --> ImagePanel.imagePanel_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
private void connEtoC2(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.imagePanel_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoM1:  (Fractal.refresh --> ImagePanel.showImage()V)
 * @param arg1 java.beans.PropertyChangeEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
private void connEtoM1(java.beans.PropertyChangeEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.showImage();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connPtoP1SetTarget:  (ImagePanel.size <--> size.this)
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
private void connPtoP1SetTarget() {
	/* Das Ziel des Quellenobjekts definieren */
	try {
		setsize(this.getSize());
		// user code begin {1}

		System.out.println ("ImagePanel -> connPtoP1SetTarget -> Size:  " + this.getSize());

//		getFractal().calculate() ; 
		
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connPtoP2SetTarget:  (size.width <--> Fractal.xmax)
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
private void connPtoP2SetTarget() {
	/* Das Ziel des Quellenobjekts definieren */
	try {
		if ((getFractal() != null) && (getsize() != null)) {
			getFractal().setXmax(new Double(getsize().getWidth()).intValue());
		}
		// user code begin {1}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connPtoP3SetTarget:  (size.height <--> Fractal.ymax)
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
private void connPtoP3SetTarget() {
	/* Das Ziel des Quellenobjekts definieren */
	try {
		if ((getFractal() != null) && (getsize() != null)) {
			getFractal().setYmax(new Double(getsize().getHeight()).intValue());
		}
		// user code begin {1}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Die Methode createImage ausfhren.
 */

public void createImage() {

	Fractal f = getFractal() ;
	
//	f.calculate() ;
	
	MemoryImageSource memoryImagesSource = new MemoryImageSource (f.getXmax(),f.getYmax(),f.getFieldPixels(),0,f.getXmax()) ;

	Image image = createImage(memoryImagesSource) ;
		
	setImage(image);	

	paint(this.getGraphics());
	
	repaint();	
}
/**
 * berprft die Gleichheit von zwei Objekten. Gibt einen booleschen Wert
 * zurck, um anzugeben, ob dieses Objekt quivalent zum angegebenen Objekt
 * ist. Diese Methode wird verwendet, wenn ein Objekt in einer Hash-Tabelle gespeichert wird.
 * @param obj das Objekt, mit dem verglichen werden soll
 * @return true, wenn diese Objekte gleich sein sollen; andernfalls false.
 * @see java.util.Hashtable
 */
public boolean equals(Object obj) {
	// Hier Code einfgen, um den Empfnger und obj zu vergleichen.
	// Diese Implementierung leitet die Nachricht an die Superkomponente weiter. Sie knnen dies ersetzen oder ergnzen.
	// HINWEIS: obj kann eine Instanz einer beliebigen Klasse sein.
	return super.equals(obj);
}
/**
 * Ruft den Eigenschaftswert akt_x (double) ab.
 * @return Der Eigenschaftswert akt_x.
 * @see #setAkt_x
 */
public double getAkt_x() {
	return fieldAkt_x;
}
/**
 * Ruft den Eigenschaftswert akt_y (double) ab.
 * @return Der Eigenschaftswert akt_y.
 * @see #setAkt_y
 */
public double getAkt_y() {
	return fieldAkt_y;
}
/**
 * Den Eigenschaftswert Fractal zurckgeben.
 * @return apf.model.Fractal
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
private apf.model.Fractal getFractal() {
	// user code begin {1}
	// user code end
	return ivjFractal;
}
/**
 * Die Methode wurde zur Untersttzung der Hochstufung von Attribut fractalThis generiert.
 * @return apf.model.Fractal
 */
public apf.model.Fractal getFractalThis() {
	return getFractal();
}
/**
 * Die Beschreibung der Methode hier eingeben.
 * Erstellungsdatum: (04.07.2002 12:12:25)
 * @return java.awt.Image
 */
public java.awt.Image getImage() {
	return image;
}
/**
 * Den Eigenschaftswert size zurckgeben.
 * @return java.awt.Dimension
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
private java.awt.Dimension getsize() {
	// user code begin {1}
	// user code end
	return ivjsize;
}
/**
 * Wird aufgerufen, wenn die Komponente eine Ausnahmebedingung bergibt.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Entfernen Sie den Kommentar fr die folgenden Zeilen, um nicht abgefangene Ausnahmebedingungen auf der Standardausgabeeinheit (stdout) auszugeben */
	// System.out.println("--------- NICHT ABGEFANGENE AUSNAHMEBEDINGUNG ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Generiert einen Hash-Code fr den Empfnger.
 * Diese Methode wird primr fr
 * Hash-Tabellen untersttzt, die z. B. in java.util zur Verfgung gestellt werden.
 * @return ein Integer-Hash-Code fr den Empfnger
 * @see java.util.Hashtable
 */
public int hashCode() {
	// Hier Code einfgen, um einen Hash-Code fr den Empfnger zu erstellen.
	// Diese Implementierung  leitet die Nachricht an die Superkomponente weiter. Sie knnen dies ersetzen oder ergnzen.
	// HINWEIS: wenn zwei Objekte gleich sind (equals(Object) gibt true zurck), mssen sie denselben Hash-Code aufweisen
	return super.hashCode();
}
/**
 * Comment
 */
public void imagePanel_MouseClicked(java.awt.event.MouseEvent mouseEvent) {

	System.out.println ("click");


	double von_x , bis_x , max_x , akt_x ;
	double von_y , bis_y , max_y , akt_y ;

	akt_x =  getAkt_x() ;
	akt_y =  getAkt_y() ;
			 
	von_x = getFractal().getAchse_x().getVon() ;
	bis_x = getFractal().getAchse_x().getBis() ;

	von_y = getFractal().getAchse_y().getVon() ;
	bis_y = getFractal().getAchse_y().getBis() ;

	getFractal().getAchse_x().setVon(akt_x - ((bis_x - von_x) / 5));
	getFractal().getAchse_x().setBis(akt_x + ((bis_x - von_x) / 5));	 

	getFractal().getAchse_y().setVon(akt_y - ((bis_y - von_y) / 5));
	getFractal().getAchse_y().setBis(akt_y + ((bis_y - von_y) / 5));	 

	von_x = getFractal().getConst_1().getVon() ;
	bis_x = getFractal().getConst_1().getBis() ;

	von_y = getFractal().getConst_2().getVon() ;
	bis_y = getFractal().getConst_2().getBis() ;

	getFractal().getConst_1().setVon((bis_x - von_x) / 2 - ((bis_x - von_x) / 5));
	getFractal().getConst_1().setBis((bis_x - von_x) / 2 + ((bis_x - von_x) / 5));	 

	getFractal().getConst_2().setVon((bis_y - von_y) / 2 - ((bis_y - von_y) / 5));
	getFractal().getConst_2().setBis((bis_y - von_y) / 2 + ((bis_y - von_y) / 5));	 






	
	getFractal().calculate();
}
/**
 * Comment
 */
public void imagePanel_MouseMoved(java.awt.event.MouseEvent mouseEvent) {

	double von_x , bis_x , max_x ; //, akt_x ;
	double von_y , bis_y , max_y ; //, akt_y ;
	
	max_x = getFractal().getXmax() ;
	max_y = getFractal().getYmax() ;
	 
	von_x = getFractal().getAchse_x().getVon() ;
	bis_x = getFractal().getAchse_x().getBis() ;

	von_y = getFractal().getAchse_y().getVon() ;
	bis_y = getFractal().getAchse_y().getBis() ;
	
	setAkt_x (von_x + ( (bis_x - von_x) / max_x *    mouseEvent.getX()           ) ) ;
	setAkt_y (von_y + ( (bis_y - von_y) / max_y * (- mouseEvent.getY() + max_y)  ) ) ;

//	System.out.println("imagePanel_MouseMoved: " + mouseEvent.getX() + ", "+ mouseEvent.getY());

//	System.out.println("imagePanel_MouseMoved: " + akt_x + ", "+ akt_y);
	
}
/**
 * Initialisiert Verbindungen
 * @exception java.lang.Exception Die Beschreibung der Ausnahmebedingung.
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	this.addComponentListener(this);
	this.addMouseMotionListener(this);
	this.addMouseListener(this);
	connPtoP1SetTarget();
	connPtoP2SetTarget();
	connPtoP3SetTarget();
}
/**
 * Die Klasse initialisieren.
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		setName("ImagePanel");
		setLayout(null);
		setSize(800, 600);
		initConnections();
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
/**
 * Startet die Anwendung.
 * @param args ein Array von Befehlszeilenargumenten
 */
public static void main(java.lang.String[] args) {
	// Hier Code einfgen, um die Anwendung zu starten.
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle MouseListener.
 * @param e java.awt.event.MouseEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void mouseClicked(java.awt.event.MouseEvent e) {
	// user code begin {1}
	// user code end
	if (e.getSource() == this) 
		connEtoC2(e);
	// user code begin {2}
	// user code end
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle MouseMotionListener.
 * @param e java.awt.event.MouseEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void mouseDragged(java.awt.event.MouseEvent e) {
	// user code begin {1}
	// user code end
	// user code begin {2}
	// user code end
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle MouseListener.
 * @param e java.awt.event.MouseEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void mouseEntered(java.awt.event.MouseEvent e) {
	// user code begin {1}
	// user code end
	// user code begin {2}
	// user code end
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle MouseListener.
 * @param e java.awt.event.MouseEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void mouseExited(java.awt.event.MouseEvent e) {
	// user code begin {1}
	// user code end
	// user code begin {2}
	// user code end
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle MouseMotionListener.
 * @param e java.awt.event.MouseEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void mouseMoved(java.awt.event.MouseEvent e) {
	// user code begin {1}
	// user code end
	if (e.getSource() == this) 
		connEtoC1(e);
	// user code begin {2}
	// user code end
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle MouseListener.
 * @param e java.awt.event.MouseEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void mousePressed(java.awt.event.MouseEvent e) {
	// user code begin {1}
	// user code end
	// user code begin {2}
	// user code end
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle MouseListener.
 * @param e java.awt.event.MouseEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void mouseReleased(java.awt.event.MouseEvent e) {
	// user code begin {1}
	// user code end
	// user code begin {2}
	// user code end
}
/**
 * Die Methode paint ausfhren.
 * @param g java.awt.Graphics
 */
public void paint(Graphics g) {

//	super.paint(g); //	System.out.println("paint Image -> " + getImage());
		
	if (getImage() != null) g.drawImage(image,0,0,this);
}
/**
 * Methode fr die Bearbeitung von Ereignissen fr die Schnittstelle PropertyChangeListener.
 * @param evt java.beans.PropertyChangeEvent
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
public void propertyChange(java.beans.PropertyChangeEvent evt) {
	// user code begin {1}
	// user code end
	if (evt.getSource() == getFractal() && (evt.getPropertyName().equals("refresh"))) 
		connEtoM1(evt);
	// user code begin {2}
	// user code end
}
/**
 * Die Methode reset ausfhren.
 */
public void reset() {

	setFractal(new Fractal()) ;
	
	// if (getFractal() != null) getFractal().reset();
}
/**
 * Definiert den Eigenschaftswert akt_x (double).
 * @param akt_x Der neue Wert fr die Eigenschaft.
 * @see #getAkt_x
 */
public void setAkt_x(double akt_x) {
	double oldValue = fieldAkt_x;
	fieldAkt_x = akt_x;
	firePropertyChange("akt_x", new Double(oldValue), new Double(akt_x));
}
/**
 * Definiert den Eigenschaftswert akt_y (double).
 * @param akt_y Der neue Wert fr die Eigenschaft.
 * @see #getAkt_y
 */
public void setAkt_y(double akt_y) {
	double oldValue = fieldAkt_y;
	fieldAkt_y = akt_y;
	firePropertyChange("akt_y", new Double(oldValue), new Double(akt_y));
}
/**
 * Die Beschreibung der Methode hier eingeben.
 * Erstellungsdatum: (05.07.2002 19:48:12)
 * @param newIvjFractal apf.model.Fractal
 */
public void setFractal(apf.model.Fractal newValue) {
	if (ivjFractal != newValue) {
		try {
			apf.model.Fractal oldValue = getFractal();
			/* Nicht mehr auf den Empfang von Ereignissen des aktuellen Objekts warten */
			if (ivjFractal != null) {
				ivjFractal.removePropertyChangeListener(this);
			}
			ivjFractal = newValue;

			/* Auf den Empfang von Ereignissen des neuen Objekts warten */
			if (ivjFractal != null) {
				ivjFractal.addPropertyChangeListener(this);
			}
			connPtoP2SetTarget();
			connPtoP3SetTarget();
			firePropertyChange("fractalThis", oldValue, newValue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	// user code begin {3}
	// user code end
}
/**
 * Die Methode wurde zur Untersttzung der Hochstufung von Attribut fractalThis generiert.
 * @param arg1 apf.model.Fractal
 */
public void setFractalThis(apf.model.Fractal arg1) {
	setFractal(arg1);
}
/**
 * Die Beschreibung der Methode hier eingeben.
 * Erstellungsdatum: (04.07.2002 12:12:25)
 * @param newImage java.awt.Image
 */
public void setImage(java.awt.Image newImage) {
	image = newImage;
}
/**
 * Fr size einen neuen Wert definieren.
 * @param newValue java.awt.Dimension
 */
/* WARNUNG: DIESE METHODE WIRD ERNEUT GENERIERT. */
private void setsize(java.awt.Dimension newValue) {
	if (ivjsize != newValue) {
		try {
			ivjsize = newValue;
			connPtoP2SetTarget();
			connPtoP3SetTarget();
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	// user code begin {3}
	// user code end
}
/**
 * Die Methode showImage ausfhren.
 */
public void showImage() {
	
	Fractal f = getFractal() ;
	
//	f.calculate() ;
	
	MemoryImageSource memoryImagesSource = new MemoryImageSource (f.getXmax(),f.getYmax(),f.getFieldPixels(),0,f.getXmax()) ;

	Image image = createImage(memoryImagesSource) ;
		
	setImage(image);	

	paint(this.getGraphics());
	
	repaint();	
}
/**
 * Gibt eine Zeichenfolge zurck, die den Wert dieses Objekts darstellt.
 * @return eine Zeichenfolgedarstellung des Empfngers
 */
public String toString() {
	// Hier Code einfgen, um den Empfnger auszugeben.
	// Diese Implementierung leitet die Nachricht an die Superkomponente weiter. Sie knnen dies ersetzen oder ergnzen.
	return super.toString();
}
/**
 * Die Methode update ausfhren.
 * @param g java.awt.Graphics
 */
public void update(Graphics g) {

	System.out.println("update");
	
	if (getImage() != null)	g.drawImage(image,10,30,this);
}
}
