package apf.model;

/**
 * Die Beschreibung des Typs hier eingeben.
 * Erstellungsdatum: (06.07.2002 17:28:39)
 * @author: Manuel Krger
 */
public class Achse {
	private double fieldValue = 0;
	private double fieldVon = 0;
	private double fieldBis = 0;
	private double fieldConstant = 0;
/**
 * Achse - Konstruktorkommentar.
 */
public Achse() {
	super();
}
/**
 * berprft die Gleichheit von zwei Objekten. Gibt einen booleschen Wert
 * zurck, um anzugeben, ob dieses Objekt quivalent zum angegebenen Objekt
 * ist. Diese Methode wird verwendet, wenn ein Objekt in einer Hash-Tabelle gespeichert wird.
 * @param obj das Objekt, mit dem verglichen werden soll
 * @return true, wenn diese Objekte gleich sein sollen; andernfalls false.
 * @see java.util.Hashtable
 */
public boolean equals(Object obj) {
	// Hier Code einfgen, um den Empfnger und obj zu vergleichen.
	// Diese Implementierung leitet die Nachricht an die Superkomponente weiter. Sie knnen dies ersetzen oder ergnzen.
	// HINWEIS: obj kann eine Instanz einer beliebigen Klasse sein.
	return super.equals(obj);
}
/**
 * Ruft den Eigenschaftswert bis (double) ab.
 * @return Der Eigenschaftswert bis.
 * @see #setBis
 */
public double getBis() {
	return fieldBis;
}
/**
 * Ruft den Eigenschaftswert constant (double) ab.
 * @return Der Eigenschaftswert constant.
 * @see #setConstant
 */
public double getConstant() {
	return fieldConstant;
}
/**
 * Ruft den Eigenschaftswert value (double) ab.
 * @return Der Eigenschaftswert value.
 * @see #setValue
 */
public double getValue() {
	return fieldValue;
}
/**
 * Ruft den Eigenschaftswert von (double) ab.
 * @return Der Eigenschaftswert von.
 * @see #setVon
 */
public double getVon() {
	return fieldVon;
}
/**
 * Generiert einen Hash-Code fr den Empfnger.
 * Diese Methode wird primr fr
 * Hash-Tabellen untersttzt, die z. B. in java.util zur Verfgung gestellt werden.
 * @return ein Integer-Hash-Code fr den Empfnger
 * @see java.util.Hashtable
 */
public int hashCode() {
	// Hier Code einfgen, um einen Hash-Code fr den Empfnger zu erstellen.
	// Diese Implementierung  leitet die Nachricht an die Superkomponente weiter. Sie knnen dies ersetzen oder ergnzen.
	// HINWEIS: wenn zwei Objekte gleich sind (equals(Object) gibt true zurck), mssen sie denselben Hash-Code aufweisen
	return super.hashCode();
}
/**
 * Startet die Anwendung.
 * @param args ein Array von Befehlszeilenargumenten
 */
public static void main(java.lang.String[] args) {
	// Hier Code einfgen, um die Anwendung zu starten.
}
/**
 * Definiert den Eigenschaftswert bis (double).
 * @param bis Der neue Wert fr die Eigenschaft.
 * @see #getBis
 */
public void setBis(double bis) {
	fieldBis = bis;
}
/**
 * Definiert den Eigenschaftswert constant (double).
 * @param constant Der neue Wert fr die Eigenschaft.
 * @see #getConstant
 */
public void setConstant(double constant) {
	fieldConstant = constant;
}
/**
 * Definiert den Eigenschaftswert value (double).
 * @param value Der neue Wert fr die Eigenschaft.
 * @see #getValue
 */
public void setValue(double value) {
	fieldValue = value;
}
/**
 * Definiert den Eigenschaftswert von (double).
 * @param von Der neue Wert fr die Eigenschaft.
 * @see #getVon
 */
public void setVon(double von) {
	fieldVon = von;
}
/**
 * Gibt eine Zeichenfolge zurck, die den Wert dieses Objekts darstellt.
 * @return eine Zeichenfolgedarstellung des Empfngers
 */
public String toString() {
	// Hier Code einfgen, um den Empfnger auszugeben.
	// Diese Implementierung leitet die Nachricht an die Superkomponente weiter. Sie knnen dies ersetzen oder ergnzen.
	return super.toString();
}
}
