package apf.model;

/**
 * Die Bean-Informationsklasse fr apf.model.Achse.
 */
public class AchseBeanInfo extends java.beans.SimpleBeanInfo {
/**
 * Ruft den Eigenschaftsdeskriptor bis ab.
 * @return java.beans.PropertyDescriptor
 */
public java.beans.PropertyDescriptor bisPropertyDescriptor() {
	java.beans.PropertyDescriptor aDescriptor = null;
	try {
		try {
			/* Die Verwendung von Methoden via getMethod bietet einen schnelleren Weg zur Erstellung des Eigenschaftsdeskriptors bis. */
			java.lang.reflect.Method aGetMethod = null;
			try {
				/* Versuchen Sie, die Methode mit Hilfe von getMethod mit Parametertypen zu lokalisieren. */
				java.lang.Class aGetMethodParameterTypes[] = {};
				aGetMethod = getBeanClass().getMethod("getBis", aGetMethodParameterTypes);
			} catch (Throwable exception) {
				/* Da getMethod fehlschlug, findMethod aufrufen. */
				handleException(exception);
				aGetMethod = findMethod(getBeanClass(), "getBis", 0);
			};
			java.lang.reflect.Method aSetMethod = null;
			try {
				/* Versuchen Sie, die Methode mit Hilfe von getMethod mit Parametertypen zu lokalisieren. */
				java.lang.Class aSetMethodParameterTypes[] = {
					double.class
				};
				aSetMethod = getBeanClass().getMethod("setBis", aSetMethodParameterTypes);
			} catch (Throwable exception) {
				/* Da getMethod fehlschlug, findMethod aufrufen. */
				handleException(exception);
				aSetMethod = findMethod(getBeanClass(), "setBis", 1);
			};
			aDescriptor = new java.beans.PropertyDescriptor("bis"
			, aGetMethod, aSetMethod);
		} catch (Throwable exception) {
			/* Da die Verwendung von Methoden fehlschlug, versuchen Sie, einen Deskriptor fr Standardeigenschaften zu erstellen. */
			handleException(exception);
			aDescriptor = new java.beans.PropertyDescriptor("bis"
			, getBeanClass());
		};
		/* aDescriptor.setBound(false); */
		/* aDescriptor.setConstrained(false); */
		/* aDescriptor.setDisplayName("bis"); */
		/* aDescriptor.setShortDescription("bis"); */
		/* aDescriptor.setExpert(false); */
		/* aDescriptor.setHidden(false); */
		aDescriptor.setValue("preferred", new Boolean(true));
		/* aDescriptor.setValue("ivjDesignTimeProperty", new Boolean(true)); */
	} catch (Throwable exception) {
		handleException(exception);
	};
	return aDescriptor;
}
/**
 * Ruft den Eigenschaftsdeskriptor constant ab.
 * @return java.beans.PropertyDescriptor
 */
public java.beans.PropertyDescriptor constantPropertyDescriptor() {
	java.beans.PropertyDescriptor aDescriptor = null;
	try {
		try {
			/* Die Verwendung von Methoden via getMethod bietet einen schnelleren Weg zur Erstellung des Eigenschaftsdeskriptors constant. */
			java.lang.reflect.Method aGetMethod = null;
			try {
				/* Versuchen Sie, die Methode mit Hilfe von getMethod mit Parametertypen zu lokalisieren. */
				java.lang.Class aGetMethodParameterTypes[] = {};
				aGetMethod = getBeanClass().getMethod("getConstant", aGetMethodParameterTypes);
			} catch (Throwable exception) {
				/* Da getMethod fehlschlug, findMethod aufrufen. */
				handleException(exception);
				aGetMethod = findMethod(getBeanClass(), "getConstant", 0);
			};
			java.lang.reflect.Method aSetMethod = null;
			try {
				/* Versuchen Sie, die Methode mit Hilfe von getMethod mit Parametertypen zu lokalisieren. */
				java.lang.Class aSetMethodParameterTypes[] = {
					double.class
				};
				aSetMethod = getBeanClass().getMethod("setConstant", aSetMethodParameterTypes);
			} catch (Throwable exception) {
				/* Da getMethod fehlschlug, findMethod aufrufen. */
				handleException(exception);
				aSetMethod = findMethod(getBeanClass(), "setConstant", 1);
			};
			aDescriptor = new java.beans.PropertyDescriptor("constant"
			, aGetMethod, aSetMethod);
		} catch (Throwable exception) {
			/* Da die Verwendung von Methoden fehlschlug, versuchen Sie, einen Deskriptor fr Standardeigenschaften zu erstellen. */
			handleException(exception);
			aDescriptor = new java.beans.PropertyDescriptor("constant"
			, getBeanClass());
		};
		/* aDescriptor.setBound(false); */
		/* aDescriptor.setConstrained(false); */
		/* aDescriptor.setDisplayName("constant"); */
		/* aDescriptor.setShortDescription("constant"); */
		/* aDescriptor.setExpert(false); */
		/* aDescriptor.setHidden(false); */
		aDescriptor.setValue("preferred", new Boolean(true));
		/* aDescriptor.setValue("ivjDesignTimeProperty", new Boolean(true)); */
	} catch (Throwable exception) {
		handleException(exception);
	};
	return aDescriptor;
}
/**
 * Die Methode durch den Vergleich (von Name & Parametergre) mit den Methoden in der Klasse feststellen.
 * @return java.lang.reflect.Method
 * @param aClass java.lang.Class
 * @param methodName java.lang.String
 * @param parameterCount int
 */
public static java.lang.reflect.Method findMethod(java.lang.Class aClass, java.lang.String methodName, int parameterCount) {
	try {
		/* Da von dieser Methode versucht wird, eine Methode durch Abruf aller Methoden aus der Klasse zu lokalisieren, 	sollte diese Methode nur aufgerufen werden, wenn getMethod die Methode nicht lokalisieren kann. */
		java.lang.reflect.Method methods[] = aClass.getMethods();
		for (int index = 0; index < methods.length; index++){
			java.lang.reflect.Method method = methods[index];
			if ((method.getParameterTypes().length == parameterCount) && (method.getName().equals(methodName))) {
				return method;
			}
		}
	} catch (java.lang.Throwable exception) {
		return null;
	}
	return null;
}
/**
 * Gibt die BeanInfo der Superklasse dieser Bean zurck, damit deren Funktionen geerbt werden knnen.
 * @return java.beans.BeanInfo[]
 */
public java.beans.BeanInfo[] getAdditionalBeanInfo() {
	java.lang.Class superClass;
	java.beans.BeanInfo superBeanInfo = null;

	try {
		superClass = getBeanDescriptor().getBeanClass().getSuperclass();
	} catch (java.lang.Throwable exception) {
		return null;
	}

	try {
		superBeanInfo = java.beans.Introspector.getBeanInfo(superClass);
	} catch (java.beans.IntrospectionException ie) {}

	if (superBeanInfo != null) {
		java.beans.BeanInfo[] ret = new java.beans.BeanInfo[1];
		ret[0] = superBeanInfo;
		return ret;
	}
	return null;
}
/**
 * Ruft die Bean-Klasse ab.
 * @return java.lang.Class
 */
public static java.lang.Class getBeanClass() {
	return apf.model.Achse.class;
}
/**
 * Ruft den Namen der Bean-Klasse ab.
 * @return java.lang.String
 */
public static java.lang.String getBeanClassName() {
	return "apf.model.Achse";
}
public java.beans.BeanDescriptor getBeanDescriptor() {
	java.beans.BeanDescriptor aDescriptor = null;
	try {
		/* Den Bean-Deskriptor AchseBeanInfo erstellen und zurckgeben. */
		aDescriptor = new java.beans.BeanDescriptor(apf.model.Achse.class);
		/* aDescriptor.setExpert(false); */
		/* aDescriptor.setHidden(false); */
		/* aDescriptor.setValue("hidden-state", Boolean.FALSE); */
	} catch (Throwable exception) {
	};
	return aDescriptor;
}
/**
 * Die Event-Set-Deskriptoren fr diese Bean zurckgeben.
 * @return java.beans.EventSetDescriptor[]
 */
public java.beans.EventSetDescriptor[] getEventSetDescriptors() {
	try {
		java.beans.EventSetDescriptor aDescriptorList[] = {};
		return aDescriptorList;
	} catch (Throwable exception) {
		handleException(exception);
	};
	return null;
}
/**
 * Die Methodendeskriptoren fr diese Bean zurckgeben.
 * @return java.beans.MethodDescriptor[]
 */
public java.beans.MethodDescriptor[] getMethodDescriptors() {
	try {
		java.beans.MethodDescriptor aDescriptorList[] = {
			main_javalangString__MethodDescriptor()
		};
		return aDescriptorList;
	} catch (Throwable exception) {
		handleException(exception);
	};
	return null;
}
/**
 * Die Eigenschaftsdeskriptoren fr diese Bean zurckgeben.
 * @return java.beans.PropertyDescriptor[]
 */
public java.beans.PropertyDescriptor[] getPropertyDescriptors() {
	try {
		java.beans.PropertyDescriptor aDescriptorList[] = {
			bisPropertyDescriptor()
			,constantPropertyDescriptor()
			,valuePropertyDescriptor()
			,vonPropertyDescriptor()
		};
		return aDescriptorList;
	} catch (Throwable exception) {
		handleException(exception);
	};
	return null;
}
/**
 * Wird aufgerufen, wenn die Bean-Informationsklasse eine Ausnahmebedingung bergibt.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Entfernen Sie den Kommentar fr die folgenden Zeilen, um nicht abgefangene Ausnahmebedingungen auf der Standardausgabeeinheit (stdout) auszugeben */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Ruft den Methodendeskriptor main(java.lang.String[]) ab.
 * @return java.beans.MethodDescriptor
 */
public java.beans.MethodDescriptor main_javalangString__MethodDescriptor() {
	java.beans.MethodDescriptor aDescriptor = null;
	try {
		/* Den Methoden-Deskriptor main(java.lang.String[]) erstellen und zurckgeben. */
		java.lang.reflect.Method aMethod = null;
		try {
			/* Versuchen Sie, die Methode mit Hilfe von getMethod mit Parametertypen zu lokalisieren. */
			java.lang.Class aParameterTypes[] = {
				java.lang.String[].class
			};
			aMethod = getBeanClass().getMethod("main", aParameterTypes);
		} catch (Throwable exception) {
			/* Da getMethod fehlschlug, findMethod aufrufen. */
			handleException(exception);
			aMethod = findMethod(getBeanClass(), "main", 1);
		};
		try {
			/* Versuchen Sie, den Methodendeskriptor mit Parameterdeskriptoren zu erstellen. */
			java.beans.ParameterDescriptor aParameterDescriptor1 = new java.beans.ParameterDescriptor();
			aParameterDescriptor1.setName("arg1");
			aParameterDescriptor1.setDisplayName("args");
			java.beans.ParameterDescriptor aParameterDescriptors[] = {
				aParameterDescriptor1
			};
			aDescriptor = new java.beans.MethodDescriptor(aMethod, aParameterDescriptors);
		} catch (Throwable exception) {
			/* Versuchen Sie, den Methodendeskriptor ohne Parameterdeskriptoren zu erstellen. */
			handleException(exception);
			aDescriptor = new java.beans.MethodDescriptor(aMethod);
		};
		/* aDescriptor.setDisplayName("main(java.lang.String[])"); */
		/* aDescriptor.setShortDescription("main(java.lang.String[])"); */
		/* aDescriptor.setExpert(false); */
		/* aDescriptor.setHidden(false); */
		/* aDescriptor.setValue("preferred", new Boolean(false)); */
	} catch (Throwable exception) {
		handleException(exception);
	};
	return aDescriptor;
}
/**
 * Ruft den Eigenschaftsdeskriptor value ab.
 * @return java.beans.PropertyDescriptor
 */
public java.beans.PropertyDescriptor valuePropertyDescriptor() {
	java.beans.PropertyDescriptor aDescriptor = null;
	try {
		try {
			/* Die Verwendung von Methoden via getMethod bietet einen schnelleren Weg zur Erstellung des Eigenschaftsdeskriptors value. */
			java.lang.reflect.Method aGetMethod = null;
			try {
				/* Versuchen Sie, die Methode mit Hilfe von getMethod mit Parametertypen zu lokalisieren. */
				java.lang.Class aGetMethodParameterTypes[] = {};
				aGetMethod = getBeanClass().getMethod("getValue", aGetMethodParameterTypes);
			} catch (Throwable exception) {
				/* Da getMethod fehlschlug, findMethod aufrufen. */
				handleException(exception);
				aGetMethod = findMethod(getBeanClass(), "getValue", 0);
			};
			java.lang.reflect.Method aSetMethod = null;
			try {
				/* Versuchen Sie, die Methode mit Hilfe von getMethod mit Parametertypen zu lokalisieren. */
				java.lang.Class aSetMethodParameterTypes[] = {
					double.class
				};
				aSetMethod = getBeanClass().getMethod("setValue", aSetMethodParameterTypes);
			} catch (Throwable exception) {
				/* Da getMethod fehlschlug, findMethod aufrufen. */
				handleException(exception);
				aSetMethod = findMethod(getBeanClass(), "setValue", 1);
			};
			aDescriptor = new java.beans.PropertyDescriptor("value"
			, aGetMethod, aSetMethod);
		} catch (Throwable exception) {
			/* Da die Verwendung von Methoden fehlschlug, versuchen Sie, einen Deskriptor fr Standardeigenschaften zu erstellen. */
			handleException(exception);
			aDescriptor = new java.beans.PropertyDescriptor("value"
			, getBeanClass());
		};
		/* aDescriptor.setBound(false); */
		/* aDescriptor.setConstrained(false); */
		/* aDescriptor.setDisplayName("value"); */
		/* aDescriptor.setShortDescription("value"); */
		/* aDescriptor.setExpert(false); */
		/* aDescriptor.setHidden(false); */
		aDescriptor.setValue("preferred", new Boolean(true));
		/* aDescriptor.setValue("ivjDesignTimeProperty", new Boolean(true)); */
	} catch (Throwable exception) {
		handleException(exception);
	};
	return aDescriptor;
}
/**
 * Ruft den Eigenschaftsdeskriptor von ab.
 * @return java.beans.PropertyDescriptor
 */
public java.beans.PropertyDescriptor vonPropertyDescriptor() {
	java.beans.PropertyDescriptor aDescriptor = null;
	try {
		try {
			/* Die Verwendung von Methoden via getMethod bietet einen schnelleren Weg zur Erstellung des Eigenschaftsdeskriptors von. */
			java.lang.reflect.Method aGetMethod = null;
			try {
				/* Versuchen Sie, die Methode mit Hilfe von getMethod mit Parametertypen zu lokalisieren. */
				java.lang.Class aGetMethodParameterTypes[] = {};
				aGetMethod = getBeanClass().getMethod("getVon", aGetMethodParameterTypes);
			} catch (Throwable exception) {
				/* Da getMethod fehlschlug, findMethod aufrufen. */
				handleException(exception);
				aGetMethod = findMethod(getBeanClass(), "getVon", 0);
			};
			java.lang.reflect.Method aSetMethod = null;
			try {
				/* Versuchen Sie, die Methode mit Hilfe von getMethod mit Parametertypen zu lokalisieren. */
				java.lang.Class aSetMethodParameterTypes[] = {
					double.class
				};
				aSetMethod = getBeanClass().getMethod("setVon", aSetMethodParameterTypes);
			} catch (Throwable exception) {
				/* Da getMethod fehlschlug, findMethod aufrufen. */
				handleException(exception);
				aSetMethod = findMethod(getBeanClass(), "setVon", 1);
			};
			aDescriptor = new java.beans.PropertyDescriptor("von"
			, aGetMethod, aSetMethod);
		} catch (Throwable exception) {
			/* Da die Verwendung von Methoden fehlschlug, versuchen Sie, einen Deskriptor fr Standardeigenschaften zu erstellen. */
			handleException(exception);
			aDescriptor = new java.beans.PropertyDescriptor("von"
			, getBeanClass());
		};
		/* aDescriptor.setBound(false); */
		/* aDescriptor.setConstrained(false); */
		/* aDescriptor.setDisplayName("von"); */
		/* aDescriptor.setShortDescription("von"); */
		/* aDescriptor.setExpert(false); */
		/* aDescriptor.setHidden(false); */
		aDescriptor.setValue("preferred", new Boolean(true));
		/* aDescriptor.setValue("ivjDesignTimeProperty", new Boolean(true)); */
	} catch (Throwable exception) {
		handleException(exception);
	};
	return aDescriptor;
}
}
